/*
 * Dozen Phi Applet
 * dozencanvas.java -- drawing class
 * (C) 1999 Visual Perception Lab, Purdue University
 * Author: Filip Pizlo
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class dozencanvas extends Canvas implements Runnable {
 public void logit(String msg) {
  System.out.println(getClass().getName()+": "+msg);
 }
 Applet base;
 Graphics vg;
 Image vbuf;
 public dozencanvas(Applet _base) {
  super();
  base=_base;
  doti=0;
  setparams(9,5,25,33);
 }
 int dots,size,radius;
 long delay;
 public synchronized void setparams(int _dots,int _size,int _radius,long _delay) {
  dots=_dots;
  size=_size;
  radius=_radius;
  delay=_delay;
  doti%=dots;
/*  logit("dots="+dots);
  logit("size="+size);
  logit("radius="+radius);
  logit("delay="+delay);*/
  dodrawing();
 }
 public void setdots(int _dots) { setparams(_dots,size,radius,delay); }
 public void setsize(int _size) { setparams(dots,_size,radius,delay); }
 public void setradius(int _radius) { setparams(dots,size,_radius,delay); }
 public void setdelay(long _delay) { setparams(dots,size,radius,_delay); }
 public int getdots() { return dots; }
 public int getsize() { return size; }
 public int getradius() { return radius; }
 public long getdelay() { return delay; }
 int doti;
 Thread dostuff;
 public void start() {
  if (!running) {
   dostuff=new Thread(this);
   cont=true;
   dostuff.start();
  }
 }
 public synchronized void stop() {
  if (running) {
   cont=false;
   notifyAll();
   dostuff=null;
  }
 }
 boolean cont=false,running=false,cmode=false,multi=false;
 Color fg=Color.white,bg=Color.black;
 public synchronized void togglecolors() {
  cmode=!cmode;
  setcolors(cmode);
  dodrawing();
 }
 public synchronized void togglemulti() {
  multi=!multi;
  dodrawing();
 }
 public void setcolors(boolean _cmode) {
  if (_cmode) setcolors(Color.black,Color.white);
  else setcolors(Color.white,Color.black);
 }
 boolean beta;
 public void setbeta(boolean _beta) {
  beta=_beta;
  dodrawing();
 }
 public boolean getbeta() { return beta; }
 public void togglebeta() { setbeta(!getbeta()); }
 public synchronized void setcolors(Color _fg,Color _bg) {
  fg=_fg;
  bg=_bg;
  dodrawing();
 }
 public Color getfgcolor() { return fg; }
 public Color getbgcolor() { return bg; }
 public synchronized void setmulti(boolean _multi) {
  multi=_multi;
  dodrawing();
 }
 double pi=3.14159,pi2=pi*2.0;
 public void dodrawing() {
  if (!imageok) return;
  double ang=0.0,dang=pi2/((double)dots);
  //logit("Angles: ang="+ang+" dang="+dang+" pi2="+pi2);
  vg.setColor(bg);
  vg.fillRect(0,0,getSize().width,getSize().height);
  vg.setColor(fg);
  int offsetx,offsety;
  if (multi) {
   offsetx=getSize().width/4;
   offsety=getSize().height/2;
  } else {
   offsetx=getSize().width/2;
   offsety=getSize().height/2;
  }
  int i=0;
  while (i<dots) {
   if ((i==doti)==beta) {
    double x=Math.cos(ang)*((double)radius);
    double y=Math.sin(ang)*((double)radius);
    //logit("Drawing: x="+x+" y="+y);
    int ix=((int)x)+offsetx;
    int iy=((int)y)+offsety;
    vg.fillOval(ix-size,iy-size,size*2,size*2);
    if (multi)
     vg.fillOval(getSize().width-ix-size,iy-size,size*2,size*2);
   }
   ang+=dang;
   i++;
  }
  repaint();
 }
 public synchronized void run() {
  try {
   running=true;
   initimage();
   while (cont) {
    dodrawing();
    try {
     wait(delay);
     doti++;
     if (doti>=dots) doti=0;
    } catch (InterruptedException e) {}
   }
  } catch (Throwable e) {
   logit("Error in thread: "+e);
  } finally {
   running=false;
  }
 }
 public void update(Graphics g) {
//  g.setColor(Color.black);
//  g.fillRect(0,0,getSize().width,getSize().height);
  paint(g);
 }
 boolean imageok=false;
 public void initimage() {
  if (imageok) return;
  logit("Creating vbuf");
  vbuf=base.createImage(getSize().width,getSize().height);
  logit("Image inited");
  vg=vbuf.getGraphics();
  logit("Graphics inited");
  imageok=true;
 }
 public void paint(Graphics g) {
  if (imageok) g.drawImage(vbuf,0,0,this);
  else g.fillRect(0,0,getSize().width,getSize().height);
 }
}



